精华内容
下载资源
问答
  • python异常处理

    万次阅读 2020-07-13 04:20:08
    try方法实现python异常处理

    方式一

        try:
            #运行可能产生异常的代码
            except#如果try后面的代码运行错误则运行这部分代码
    

    方式二

        try:
        #运行可能产生异常的代码
        except#如果try后面的代码运行错误则运行这部分代码              
        else#如果没有异常发生 
    

    没有异常处理的程序

    以爬取王者荣耀图片为例子

    import urllib.request
    import os
    # http://game.gtimg.cn/images/yxzj/img201606/skin/hero-info/191/191-bigskin-1.jpg 王者荣耀图床地址   文件夹191~529 -1表示皮肤 ,之后是-2 、-3...
    for num in range(105,600):
        # try:
            path = r'D:\文档\code\web前端\王者荣耀图库\皮肤\ '
            # os.mkdir(path + str(num))         #创建文件夹
            response = urllib.request.urlopen("http://game.gtimg.cn/images/yxzj/img201606/skin/hero-info/"+str(num)+"/"+str(num)+"-bigskin-1"+".jpg")  #图片地址
            print(response)
            wangzhe_img = response.read()
            with open('D:\文档\code\web前端\王者荣耀图库\皮肤\ '+ str(num) + '.jpg','wb') as f:
                f.write(wangzhe_img)
        # except:
        #     continue
    

    有异常处理的程序

    按照上述方式爬取图片,会遇到当网址无法打开则无法进行下一步的问题(王者荣耀图片网站并不是191~529都有图片,有些英雄之间的编号可能有间隔,因而运行程序遇到这种情况会出现error)

    为解决该问题,使用try异常处理,当遇到无法打开的网址时,直接跳过继续循环的下一个步骤,如:

    import urllib.request
    import os
    # http://game.gtimg.cn/images/yxzj/img201606/skin/hero-info/191/191-bigskin-1.jpg 王者荣耀图床地址   文件夹191~529 -1表示皮肤 ,之后是-2 、-3...
    for num in range(105,600):
        try:
            path = r'D:\文档\code\web前端\王者荣耀图库\皮肤\ '
            # os.mkdir(path + str(num))         #创建文件夹
            response = urllib.request.urlopen("http://game.gtimg.cn/images/yxzj/img201606/skin/hero-info/"+str(num)+"/"+str(num)+"-bigskin-1"+".jpg")  #图片地址
            print(response)
            wangzhe_img = response.read()
            with open('D:\文档\code\web前端\王者荣耀图库\皮肤\ '+ str(num) + '.jpg','wb') as f:
                f.write(wangzhe_img)
        except:
            continue
    
    展开全文
  • 2.2 Python异常处理

    万次阅读 2019-05-21 10:38:50
    2.2 Python异常处理 2.2.1 异常介绍: 即便Python程序的语法是正确的,在运行它的时候,也有可能发生错误。运行期检测到的错误被称为异常。 大多数的异常都不会被程序处理,都以错误信息的形式展现在这里: &...

    2.2 Python异常处理

    2.2.1 异常介绍:

    • 即便Python程序的语法是正确的,在运行它的时候,也有可能发生错误。运行期检测到的错误被称为异常。
    • 大多数的异常都不会被程序处理,都以错误信息的形式展现在这里:
    >>> 10 * (1/0)
    Traceback (most recent call last):
      File "<stdin>", line 1, in ?
    ZeroDivisionError: division by zero
    >>> 4 + spam*3
    Traceback (most recent call last):
      File "<stdin>", line 1, in ?
    NameError: name 'spam' is not defined
    >>> '2' + 2
    Traceback (most recent call last):
      File "<stdin>", line 1, in ?
    TypeError: Can't convert 'int' object to str implicitly
    
    • 异常以不同的类型出现,这些类型都作为信息的一部分打印出来: 例子中的类型有 ZeroDivisionError,NameError 和 TypeError。

    • Python的一些內建异常:

    Exception       常规错误的基类
    AttributeError  对象没有这个属性
    IOError         输入/输出操作失败
    IndexError      序列中没有此索引(index)
    KeyError        映射中没有这个键
    NameError       未声明/初始化对象 (没有属性)
    SyntaxError     Python 语法错误
    TypeError       对类型无效的操作
    ValueError      传入无效的参数
    ZeroDivisionError   除(或取模)(所有数据类型)
    
    • 更多可以参考:http://blog.csdn.net/gavin_john/article/details/50738323

    2.2.2 异常处理:

    • 没有异常处理的:特点是出现异常会终止程序执行。
    print("start.....")
    x = int(input("Please enter a number: "))
    print("number:",x)
    print("ok....")
    print("end.....")
    
    • 使用了有异常处理的代码,程序会执行到最后
    print("start.....")
    try:
        x = int(input("Please enter a number: "))
        print("number:",x)
        print("ok....")
    except ValueError:
        print("Oops!  That was no valid number.  Try again")
    print("end.....")
    
    
    • try语句按照如下方式工作;
      • 首先,执行try子句(在关键字try和关键字except之间的语句)
      • 如果没有异常发生,忽略except子句,try子句执行后结束。
      • 如果在执行try子句的过程中发生了异常,那么try子句余下的部分将被忽略。如果异常的类型和 except 之后的名称相符,那么对应的except子句将被执行。最后执行 try 语句之后的代码。
      • 如果一个异常没有与任何的except匹配,那么这个异常将会传递给上层的try中。
    • 一个 try 语句可能包含多个except子句,分别来处理不同的特定的异常。最多只有一个分支会被执行。
    • 处理程序将只针对对应的try子句中的异常进行处理,而不是其他的 try 的处理程序中的异常。
    • 一个except子句可以同时处理多个异常,这些异常将被放在一个括号里成为一个元组,例如:
        except (RuntimeError, TypeError, NameError):
            pass
    
    • 最后一个except子句可以忽略异常的名称,它将被当作通配符使用。你可以使用这种方法打印一个错误信息,然后再次把异常抛出。
    import sys
    
    try:
        f = open('myfile.txt')
        s = f.readline()
        i = int(s.strip())
    except OSError as err:
        print("OS error: {0}".format(err))
    except ValueError:
        print("Could not convert data to an integer.")
    except:
        print("Unexpected error:", sys.exc_info()[0])
        raise
    

    异常处理实例

    • 一个 try 语句可能包含多个except子句,分别来处理不同的特定的异常。最多只有一个分支会被执行
    • 最后一个except子句可以忽略异常的名称,它将被当作通配符使用
    print("start.....")
    try:
        x = int(input("Please enter a number: "))
        print("number:",x)
        print(100/x)
        print("ok....")
    except ValueError:
        print("非纯数字错误!")
    except ZeroDivisionError:
        print("不可以为零错误!")
    except:
        print("可选的未知错误!")
    print("end.....")
    
    • 一个except子句可以同时处理多个异常,这些异常将被放在一个括号里成为一个元组
    print("start.....")
    try:
        x = int(input("Please enter a number: "))
        print("number:",x)
        print(100/x)
        print("ok....")
    except (ValueError,ZeroDivisionError):
        print("非纯数字或不可以为零错误!")
    except:
        print("可选的未知错误!")
        raise   #重新抛出这个异常
    print("end.....")
    

    2.2.3 抛出异常(自行抛出异常):

    • Python 使用 raise 语句抛出一个指定的异常。例如:
    >>> raise NameError('HiThere')
    Traceback (most recent call last):
      File "<stdin>", line 1, in ?
    NameError: HiThere
    
    • raise 唯一的一个参数指定了要被抛出的异常。它必须是一个异常的实例或者是异常的类(也就是 Exception 的子类)。
    • 如果你只想知道这是否抛出了一个异常,并不想去处理它,那么一个简单的 raise 语句就可以再次把它抛出。
    >>> try:
            raise NameError('HiThere')
        except NameError:
            print('An exception flew by!')
            raise
    
    An exception flew by!
    Traceback (most recent call last):
      File "<stdin>", line 2, in ?
    NameError: HiThere
    
    展开全文
  • Python异常处理机制

    千次阅读 2017-02-28 21:43:21
    Python 异常处理 python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。 异常处理 断言(Assertions) python标准异常 异常名称 描述 ...

            python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。1、异常处理。2、断言(Assertions)

    python标准异常

    异常名称 描述
    BaseException 所有异常的基类
    SystemExit 解释器请求退出
    KeyboardInterrupt 用户中断执行(通常是输入^C)
    Exception 常规错误的基类
    StopIteration 迭代器没有更多的值
    GeneratorExit 生成器(generator)发生异常来通知退出
    StandardError 所有的内建标准异常的基类
    ArithmeticError 所有数值计算错误的基类
    FloatingPointError 浮点计算错误
    OverflowError 数值运算超出最大限制
    ZeroDivisionError 除(或取模)零 (所有数据类型)
    AssertionError 断言语句失败
    AttributeError 对象没有这个属性
    EOFError 没有内建输入,到达EOF 标记
    EnvironmentError 操作系统错误的基类
    IOError 输入/输出操作失败
    OSError 操作系统错误
    WindowsError 系统调用失败
    ImportError 导入模块/对象失败
    LookupError 无效数据查询的基类
    IndexError 序列中没有此索引(index)
    KeyError 映射中没有这个键
    MemoryError 内存溢出错误(对于Python 解释器不是致命的)
    NameError 未声明/初始化对象 (没有属性)
    UnboundLocalError 访问未初始化的本地变量
    ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
    RuntimeError 一般的运行时错误
    NotImplementedError 尚未实现的方法
    SyntaxError Python 语法错误
    IndentationError 缩进错误
    TabError Tab 和空格混用
    SystemError 一般的解释器系统错误
    TypeError 对类型无效的操作
    ValueError 传入无效的参数
    UnicodeError Unicode 相关的错误
    UnicodeDecodeError Unicode 解码时的错误
    UnicodeEncodeError Unicode 编码时错误
    UnicodeTranslateError Unicode 转换时错误
    Warning 警告的基类
    DeprecationWarning 关于被弃用的特征的警告
    FutureWarning 关于构造将来语义会有改变的警告
    OverflowWarning 旧的关于自动提升为长整型(long)的警告
    PendingDeprecationWarning 关于特性将会被废弃的警告
    RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
    SyntaxWarning 可疑的语法的警告
    UserWarning 用户代码生成的警告

    什么是异常?

            异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。一般情况下,在Python无法正常处理程序时就会发生一个异常。

            异常是Python对象,表示一个错误。当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。


    Python异常处理

            捕捉异常可以使用try/except语句。try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。

    如果你不想在异常发生时结束你的程序,只需在try里捕获它。

    以下为简单的try....except...else的语法:

    try:
    <语句>        #运行别的代码
    except <名字>:
    <语句>        #如果在try部份引发了'name'异常
    except <名字>,<数据>:
    <语句>        #如果引发了'name'异常,获得附加的数据
    else:
    <语句>        #如果没有异常发生

            try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

           1、如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。

            2、如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。

            3、如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。(注意:是没有异常时才执行else语句)。


    简单实例

    下面是简单的例子,它打开一个文件,在该文件中的内容写入内容:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print("Error: 没有找到文件或读取文件失败");
    else:
        print("内容写入文件成功");
        fh.close()


    捕获所有异常

    可以不带任何异常类型使用except,如下实例:

    try:
        正常的操作
       ......................
    except:
        发生异常,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码

            以上方式try-except语句捕获所有发生的异常。但这不是一个很好的方式,我们不能通过该程序识别出具体的异常信息。因为它捕获所有的异常。


    捕获多种异常类型

    也可以使用相同的except语句来处理多个异常信息,如下所示:

    try:
        正常的操作
       ......................
    except(Exception1[, Exception2[,...ExceptionN]]]):
       发生以上多个异常中的一个,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码


    try-finally 语句

    try-finally 语句无论是否发生异常都将执行最后的代码。

    try:
    <语句>
    finally:
    <语句>    #退出try时总会执行
    raise


    异常的参数

            一个异常可以带上参数,可作为输出的异常信息参数。可以通过except语句来捕获异常的参数,如下所示:

    try:
        正常的操作
       ......................
    except ExceptionType, Argument:
        你可以在这输出 Argument 的值...

            变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个值。元组通常包含错误字符串,错误数字,错误位置。


    触发异常

    我们可以使用raise语句自己触发异常,raise语法格式如下:

    raise [Exception [, args [, traceback]]]

            语句中Exception是异常的类型(例如,NameError)参数是一个异常参数值。该参数是可选的,如果不提供,异常的参数是"None"。最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。


    简单实例

            一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。定义一个异常非常简单,如下所示:

            注意:为了能够捕获异常,"except"语句必须有用相同的异常来抛出类对象或者字符串。

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    # 定义函数
    def mye( level ):
        if level < 1:
            raise Exception("Invalid level!", level)
            # 触发异常后,后面的代码就不会再执行
    
    try:
        mye(0)                // 触发异常
    except "Invalid level!":
        print 1
    else:
        print 2


    用户自定义异常

            通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception类,通过直接或间接的方式。以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在异常触发时输出更多的信息。在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

    class Networkerror(RuntimeError):
        def __init__(self, arg):
            self.args = arg

    在你定义以上类后,你可以触发该异常,如下所示:

    try:
        raise Networkerror("Bad hostname")
    except Networkerror,e:
        print e.args



    两个特殊的处理异常的方法

    断言(assert)

    assert expression[,reason]  
            其中assert是断言的关键字。执行该语句的时候,先判断表达式expression,如果表达式为真,则什么都不做;如果表达式不为真,则抛出异常。reason跟之前谈到的异常类的实例一样。

    上下文管理(with语句)

            如果你使用try, except, finally代码仅仅是为了保证共享资源(如文件,数据)的唯一分配,并在任务结束后释放它,那么这个with语句可以让你从try, except, finally中解放出来!语法如下:

    with context_expr [as var]:  
        with_suite  

    举个例子: view plain
    >>> with open('/root/test.py') as f:  
    ...     for line in f:  
    ...         print line 

            上面这几行代码干了什么?

            (1)打开文件/root/test.py

            (2)将文件对象赋值给  f

            (3)将文件所有行输出

           (4)无论代码中是否出现异常,Python都会为我们关闭这个文件,我们不需要关心这些细节。

           使用with语句来使用这些共享资源,我们不用担心会因为某种原因而没有释放他。但并不是所有的对象都可以使用with语句,只有支持上下文管理协议(context management protocol)的对象才可以,那哪些对象支持该协议呢?如下表:

            file 

            decimal.Context

            thread.LockType

            threading.Lock

            threading.RLock

            threading.Condition

            threading.Semaphore

            threading.BoundedSemaphore


    sys模块获取异常

            另一种获取异常信息的途径是通过sys模块中的exc_info()函数。该函数回返回一个三元组:(异常类,异常类的实例,跟中记录对象)。

    >>> try:  
    ...     1/0  
    ... except:  
    ...     import sys  
    ...     tuple = sys.exc_info()  
    ...   
    >>> print tuple  
    (<type 'exceptions.ZeroDivisionError'>, ZeroDivisionError('integer division or modulo by zero',), <traceback object at 0x7f538a318b48>)  
    >>> for i in tuple:  
    ...     print i  
    ...   
    <type 'exceptions.ZeroDivisionError'> #异常类      
    integer division or modulo by zero #异常类的实例  
    <traceback object at 0x7f538a318b48> #跟踪记录对象 
    展开全文
  • Python异常处理和异常类型

    万次阅读 2015-09-21 18:58:26
    Python异常处理和异常类型目录 Python异常处理和异常类型 目录 python2x捕获异常语法 python3x捕获异常语法 python常见的异常类型 NameError尝试访问一个未申明的变量 ZeroDivisionError除数为0 SyntaxError语法错误...

    python2.x捕获异常语法:

    try:
        ...some functions...
    except Exception, e:
        print(e)

    python3.x捕获异常语法:

    try:
        ...some functions...
    except Exception as e:
        print(e)

    注意这里 Exception, e 变成了 Exception as e

    python常见的异常类型

    1. NameError:尝试访问一个未申明的变量

    >>> v
    NameError: name 'v' is not defined

    2. ZeroDivisionError:除数为0

    >>> v = 1/0
    ZeroDivisionError: int division or modulo by zero

    3. SyntaxError:语法错误

    int int
    SyntaxError: invalid syntax (<pyshell#14>, line 1)

    4. IndexError:索引超出范围

    List = [2]
    >>> List[3]
    Traceback (most recent call last):
      File "<pyshell#18>", line 1, in <module>
        List[3]
    IndexError: list index out of range

    5. KeyError:字典关键字不存在

    Dic = {'1':'yes', '2':'no'}
    >>> Dic['3']
    Traceback (most recent call last):
      File "<pyshell#20>", line 1, in <module>
        Dic['3']
    KeyError: '3'

    6. IOError:输入输出错误

    >>> f = open('abc')
    IOError: [Errno 2] No such file or directory: 'abc'

    7. AttributeError:访问未知对象属性

    >>> class Worker:
     def Work():
      print("I am working")
    
    >>> w = Worker()
    >>> w.a
    Traceback (most recent call last):
      File "<pyshell#51>", line 1, in <module>
        w.a
    AttributeError: 'Worker' object has no attribute 'a'

    8.ValueError:数值错误

    >>> int('d')
    Traceback (most recent call last):
      File "<pyshell#54>", line 1, in <module>
        int('d')
    ValueError: invalid literal for int() with base 10: 'd'

    9. TypeError:类型错误

    >>> iStr = '22'
    >>> iVal = 22
    >>> obj = iStr + iVal;
    Traceback (most recent call last):
      File "<pyshell#68>", line 1, in <module>
        obj = iStr + iVal;
    TypeError: Can't convert 'int' object to str implicitly

    10. AssertionError:断言错误

    >>> assert 1 != 1
    Traceback (most recent call last):
      File "<pyshell#70>", line 1, in <module>
        assert 1 != 1
    AssertionError

    11.MemoryError:内存耗尽异常

    12. NotImplementedError:方法没实现引起的异常

    class Base(object):
        def __init__(self):
            pass
    
        def action(self):
            #抛出异常,说明该接口方法未实现
            raise NotImplementedError

    13. LookupError:键、值不存在引发的异常

    LookupError异常是IndexError、KeyError的基类, 如果你不确定数据类型是字典还是列表时,可以用LookupError捕获此异常

    14. StandardError 标准异常

    除StopIteration, GeneratorExit, KeyboardInterrupt 和SystemExit外,其他异常都是StandarError的子类。

    错误检测与异常处理区别在于:错误检测是在正常的程序流中,处理不可预见问题的代码,例如一个调用操作未能成功结束。

    展开全文
  • Python 异常处理

    千次阅读 2017-09-27 17:30:08
    异常处理是一门艺术,更是优秀程序员必修之路。 在某些情况下(例如:试图读取一个不存在的文件),程序可能会发生运行时错误。一旦程序崩溃,用户的心情可想而知。。。 当然,作为程序员,我们希望程序足够健壮...
  • Python异常处理

    千次阅读 2018-11-01 19:26:24
    异常就是程序运行时发生错误的信号(在程序出现错误时,则会产生一个异常,若程序没有处理它,则会抛出该异常,程序的运行也随之终止),在python中,错误触发的异常如下 Traceback叫做异常的追踪信息,我们可以通过...
  • Python异常处理 -跳过异常继续执行

    万次阅读 多人点赞 2019-02-19 15:01:48
    Python异常处理 -跳过异常继续执行 python一般使用try…except…处理异常 try: #可能会出现异常的代码,放在try下 code1 #如何try内部任意一行代码出现异常,# 直接跳转至except,执行except下代码 code2 except: ...
  • python异常处理和日志处理

    千次阅读 2018-03-23 14:01:33
    python异常处理和日志处理 今天,总结一下最近编程使用的python异常处理和日志处理的感受,其实异常处理是程序编写时非常重要 的一块,但是我一开始学的语言是C++,这门语言中没有强制要求使用try...catch语句,...
  • Python异常处理(基础详解)

    千次阅读 多人点赞 2020-04-06 13:52:05
    本文是python异常的基础知识,欢迎阅读,一起进步 Python专栏请参考:人生苦短-我学python 文章目录一.异常简介二.捕获异常三.异常的传递四.抛出自定义的异常五.模块六.模块制作七.python中的包 一.异常简介 ...
  • python异常处理和IO操作

    千次阅读 2020-09-08 12:16:23
    文章目录异常处理异常处理捕获指定异常查看 报错类型 ,获取报错类型并打印自定义 异常 异常处理 详细可以见官网:https://docs.python.org/zh-cn/3/tutorial/errors.html 异常处理 语法: try: 可能出现异常的代码 ...
  • python异常处理和断言

    万次阅读 2015-08-23 17:46:54
    此外,发生异常也意味着表达式为假.这些工作类似于 C 语言预处理器中 assert 宏,但在 Python 中它们在运行时构建(与之相对的是编译期判别). 如果你刚刚接触断言这个概念,无妨.断言可以简简单单的想象为 raise-if 语句...
  • python异常处理

    万次阅读 2018-08-10 22:22:36
    Python 异常处理 python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。 异常处理: 本站Python教程会具体介绍。 断言(Assertions):本站Python教程会具体...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 206,424
精华内容 82,569
关键字:

python异常处理的作用

python 订阅